VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "Number Converter"
   ClientHeight    =   1980
   ClientLeft      =   825
   ClientTop       =   1110
   ClientWidth     =   7650
   Icon            =   "Bin.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1980
   ScaleWidth      =   7650
   Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
      Height          =   1335
      Left            =   0
      TabIndex        =   1
      Top             =   480
      Width           =   7695
      _ExtentX        =   13573
      _ExtentY        =   2355
      _Version        =   393216
      Rows            =   5
      Cols            =   5
      AllowUserResizing=   3
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      ItemData        =   "Bin.frx":000C
      Left            =   720
      List            =   "Bin.frx":004C
      TabIndex        =   0
      Top             =   120
      Width           =   3375
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Function Bin(Number) ' both Variants
' #Binary BITS# by Chris
' based on the Two's-Complement "shortcut" method
'===========================================
Dim BitStream() As Byte
Dim Bits As Byte
Dim BitPointer As Byte
Dim HexString As String
Dim lenHS As Integer
Dim HalfByte As Byte ' smallest VB word
Dim i As Integer
Dim j As Integer

Const DABug As Boolean = False
On Error GoTo eror

Select Case VarType(Number)
Case vbNull
'pass a null, return a null
 Bin = Number
 Exit Function
Case vbByte
' 0 to 255 unsigned
 Bits = 8
Case vbInteger, vbBoolean
' -32,768 to 32,767
 Bits = 16
Case vbLong
' -2,147,483,648 to 2,147,483,647
 Bits = 32
Case vbSingle, vbDouble
 Bits = 32
' HEX() will convert these
'  to Longs (if possible!)
Case vbString
'-a Number of unspecified Type-
''Note: This expects a String to be a Number
''  To get the bits for a String, try this code:
''(Pass it in a BYTE at a time!)
''Dim BS() As Byte
''BS = MyString '-or- BS = StrConv(MyString, vbFromUnicode)
''For i = LBound(BS) To UBound(BS)
''  Print Bin(BS(i)),
''Next i
Case Else
 Err.Raise 2001, , "Not sure HOW to handle a (" & TypeName(Number) & ") DATA TYPE?"
End Select

'' if HEX() can't handle it,
'' then neither can this code!
HexString = Hex(Number)
lenHS = Len(HexString)

If Bits = 0 Then Bits = lenHS * 4 'bits
ReDim BitStream(1 To Bits)
BitPointer = Bits

For i = lenHS To 1 Step -1
  HalfByte = Val("&H" & Mid(HexString, i, 1))
  For j = 1 To 4 ' bits
   If HalfByte Then
     BitStream(BitPointer) = HalfByte Mod 2
     HalfByte = Fix(HalfByte / 2)
   End If
   BitPointer = BitPointer - 1
  Next j
Next i

'now add 48 to all bits(bytes) for "0" or "1"
For i = 1 To Bits
  BitStream(i) = BitStream(i) + 48
Next i

Bin = StrConv(BitStream, vbUnicode)
' format it
Bin = Trim(Format(Bin, "&&&&&&&& &&&&&&&& &&&&&&&& &&&&&&&&"))
'(format it here?  or outside this proc?)
Exit Function

eror:
If DABug Then Debug.Print Err.Number & "-" & Err.Description
Err.Clear
Bin = "0"
End Function

Private Sub Combo1_Change()
If Trim(Combo1.Text) = vbNullString Then Exit Sub

On Error Resume Next
Dim test As Variant

test = CByte(Combo1.Text)
If Err Then
  MSFlexGrid1.TextMatrix(1, 1) = "error!"
  MSFlexGrid1.TextMatrix(1, 2) = vbNullString
  MSFlexGrid1.TextMatrix(1, 3) = vbNullString
  MSFlexGrid1.TextMatrix(1, 4) = vbNullString
  Err.Clear
Else
  MSFlexGrid1.TextMatrix(1, 1) = test
  MSFlexGrid1.TextMatrix(1, 2) = Hex(test)
  MSFlexGrid1.TextMatrix(1, 3) = Oct(test)
  MSFlexGrid1.TextMatrix(1, 4) = Bin(test)
End If


test = CInt(Combo1.Text)
If Err Then
  MSFlexGrid1.TextMatrix(2, 1) = "error!"
  MSFlexGrid1.TextMatrix(2, 2) = vbNullString
  MSFlexGrid1.TextMatrix(2, 3) = vbNullString
  MSFlexGrid1.TextMatrix(2, 4) = vbNullString
  Err.Clear
Else
  MSFlexGrid1.TextMatrix(2, 1) = test
  MSFlexGrid1.TextMatrix(2, 2) = Hex(test)
  MSFlexGrid1.TextMatrix(2, 3) = Oct(test)
  MSFlexGrid1.TextMatrix(2, 4) = Bin(test)
End If


test = CLng(Combo1.Text)
If Err Then
  MSFlexGrid1.TextMatrix(3, 1) = "error!'"
  MSFlexGrid1.TextMatrix(3, 2) = vbNullString
  MSFlexGrid1.TextMatrix(3, 3) = vbNullString
  MSFlexGrid1.TextMatrix(3, 4) = vbNullString
  Err.Clear
Else
  MSFlexGrid1.TextMatrix(3, 1) = test
  MSFlexGrid1.TextMatrix(3, 2) = Hex(test)
  MSFlexGrid1.TextMatrix(3, 3) = Oct(test)
  MSFlexGrid1.TextMatrix(3, 4) = Bin(test)
End If


'?test = Val(Combo1.Text)
'?If Err Then
''  test = "error!"
''  Err.Clear
''End If
''MSFlexGrid1.TextMatrix(1, 4) = test
'MSFlexGrid1.TextMatrix(0, 2) = "Integer (16bit)"
End Sub

Private Sub Combo1_Click()
Combo1_Change
End Sub

Private Sub Form_Load()
'setup
MSFlexGrid1.Rows = 4 '5
MSFlexGrid1.Cols = 5
'row headers
MSFlexGrid1.TextMatrix(1, 0) = "Byte (8bit)"
MSFlexGrid1.TextMatrix(2, 0) = "Integer (16bit)"
MSFlexGrid1.TextMatrix(3, 0) = "Long (32bit)"
'col headers
MSFlexGrid1.TextMatrix(0, 1) = "Decimal"
MSFlexGrid1.TextMatrix(0, 2) = "Hex"
MSFlexGrid1.TextMatrix(0, 3) = "Octal"
MSFlexGrid1.TextMatrix(0, 4) = "Binary"
MSFlexGrid1.ColWidth(1) = TextWidth(String(12, "0"))
MSFlexGrid1.ColWidth(0) = MSFlexGrid1.ColWidth(1)
MSFlexGrid1.ColWidth(2) = MSFlexGrid1.ColWidth(1)
MSFlexGrid1.ColWidth(3) = MSFlexGrid1.ColWidth(1)
MSFlexGrid1.ColWidth(4) = MSFlexGrid1.ColWidth(1) * 3
MSFlexGrid1.ColAlignment(1) = flexAlignRightBottom
MSFlexGrid1.ColAlignment(2) = flexAlignRightBottom
End Sub
